.\" Process this file with
.\" groff -man -Tascii dgas_sensors.conf.5
.\"
.TH DGAS_SENSORS.CONF 5 "MARCH 2011" Linux "User Manuals"
.SH NAME
dgas_sensors.conf Configuration file
.SH DESCRIPTION
.B dgas_sensors.conf
This is the configuration file for the Distributed Grid Accounting System Sensors.
.SH SITE SPECIFIC OPTIONS
These ptions need to be explicitely configured by the system manager in order for
the DGAS sensors to start retrieving records.
.IP siteName
siteName parameter can be used to assign to the UsageRecord a tag identifying
the site. Example: "INFN-TORINO".
.IP lrmsType
This parameter specifies the LRMS type and _has to be set_. Possible values: 
"pbs", "lsf", "sge", "condor".
.IP pbsAcctLogDir
This is the location of the directory where PBS accounting logs are stored. This needs to be set up if lrmsType="pbs"
.IP lsfAcctLogDir
This is the location of the directory where LSF accounting logs are stored. This needs to be set up if lrmsType="lsf"
.IP sgeAcctLogDir
This is the location of the directory where SGE accounting logs are stored. This needs to be set up if lrmsType="sge"
.IP res_acct_bank_id 
resource HLR: in the form host:port:[X509_certSubject] it is used for the legacy producer using the atmClient command
.IP ignoreJobsLoggedBefore
This specifies the date (YYYY-MM-DD) from which to recorver records from the system logs.
.IP useCEJobMap
Specifies wheter to use grid related information when composing the usage records (values: yes/no)
.IP ceJobMapLog
This is the location of the CE's grid user/grid job -> local job ID map.
 It has to be specified _either_ as a directory (containing file names such as
 "20050307" or "2005-03-07") _or_ as a file name prefix (including path)

 Examples for matching log file names:

 "<ceJobMapLog>20060309(.gz)" (one file per day; as prefix)
 "<ceJobMapLog>(- or _)20060309(.gz)" (one file per day; as prefix)
 "<ceJobMapLog>/20060309(.gz)" (one file per day: in dir)

 "<ceJobMapLog>2006-03-09(.gz)" (one file per day; as prefix)
 "<ceJobMapLog>(- or _)2006-03-09(.gz)" (one file per day; as prefix)
 "<ceJobMapLog>/2006-03-09(.gz)" (one file per day; in dir)

 "<ceJobMapLog>(.gz)" (single file; as prefix)
 "<ceJobMapLog>.1(.gz)" (single file rotated; as prefix)
.IP transportLayer
transportLayer specifies the transport mechanisms that can be used.
the 'Legacy' (default) value automatically set up the older, backward compatible 
mechanism adopted in earlier versions of DGAS.

.SH DAEMON CONFIGURATION OPTIONS


 
.SH FILES
.I /etc/dgas/dgas_sensors.conf
.RS
The system wide configuration file. See
.BR dgas-pushd (5),dgas-urcollector (5)
for further details.
.RE
.SH AUTHOR
Andrea Guarise <andrea.guarise at to dot infn dot it>
.SH "SEE ALSO"
.BR dgas-pushd (5),
.BR dgas-urcollector (5),
